package activable;

import java.rmi.MarshalledObject;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.activation.Activatable;
import java.rmi.activation.ActivationDesc;
import java.rmi.activation.ActivationException;
import java.rmi.activation.ActivationGroup;
import java.rmi.activation.ActivationGroupDesc;
import java.rmi.activation.ActivationGroupID;
import java.util.Properties;

public class Setup {

    public static void main(String[] args) {

	System.setSecurityManager (new RMISecurityManager() {
		public void checkConnect (String host, int port) {}
		public void checkConnect (String host, int port, Object context) {}
		public void checkRead(String filename) {}
		});

 	Properties props = new Properties(); 
        props.put("java.security.policy", "d:\\book\\workspace\\rmiactivation\\myrmi.policy");
        props.put("java.rmi.server.codebase", "file:/d:/book/workspace/rmiactivation/");
        ActivationGroupDesc.CommandEnvironment ace = null; 
 	ActivationGroupDesc exampleGroup = new ActivationGroupDesc(props, ace);
 	try {
        ActivationGroupID 

			agi = ActivationGroup.getSystem().registerGroup(exampleGroup);
		

	String location = "file:/D:/Book/workspace/RMIActivation/";

	MarshalledObject data = null;

       	ActivationDesc desc = new ActivationDesc 
	    (agi, "activable.PaymentActivableImpl",location, data);

	PaymentActivable mort = (PaymentActivable)Activatable.register(desc);
	System.out.println("Got the stub for PaymentActivableImpl");
       
	Naming.rebind("Mortgage", mort);
	System.out.println("Exported from registration");

	System.exit(0);
 	}  catch (Exception e) {e.printStackTrace();}

}}